//+------------------------------------------------------------------+
//|                                                   Copy Lines.mq4 |
//|                                                    Keith Watford |
//|                                                             none |
//+------------------------------------------------------------------+
#property copyright "Keith Watford"
#property link      "none"
#property version   "1.00"
#property strict

string FileName="Objects.txt";
#include <stdlib.mqh>
#include <stderror.mqh>
//+------------------------------------------------------------------+
//| Script program start function                                    |
//+------------------------------------------------------------------+
void OnStart()
  {
  
   FileDelete(FileName,FILE_COMMON);
   ResetLastError();
   int handle = FileOpen(FileName,FILE_SHARE_READ|FILE_READ|FILE_WRITE|FILE_COMMON|FILE_TXT )  ;
   if(handle<0)
     {
     Print("Error opening file ",FileName,". Error- ",ErrorDescription(GetLastError() ) );
     return;
     }
  
  string text,t1,p1,t2,p2,ray,window,col,width,style,back;
  for(int x=ObjectsTotal()-1;x>=0;x--)
     {
     string name=ObjectName(x);
     int obtype=ObjectType(name);
     if(obtype==OBJ_TREND)
        {
        text=name+",Trend,";
        window=IntegerToString(ObjectFind(0,name));
        t1=TimeToStr((datetime)ObjectGet(name,OBJPROP_TIME1));
        p1=DoubleToStr(ObjectGet(name,OBJPROP_PRICE1),Digits);
        t2=TimeToStr((datetime)ObjectGet(name,OBJPROP_TIME2));
        p2=DoubleToStr(ObjectGet(name,OBJPROP_PRICE2),Digits);
        if(ObjectGet(name,OBJPROP_RAY))
           ray="true";
        else
           ray="false";
        //col=ColorToString((color)ObjectGet(name,OBJPROP_COLOR),true);
        col=IntegerToString(ObjectGetInteger(0,name,OBJPROP_COLOR));
        width=IntegerToString((int)ObjectGet(name,OBJPROP_WIDTH));
        style=IntegerToString((int)ObjectGet(name,OBJPROP_STYLE));
        back=IntegerToString(ObjectGetInteger(0,name,OBJPROP_BACK));
        text+=window+","+t1+","+p1+","+t2+","+p2+","+ray+","+col+","+width+","+style+","+back;
      uint checkwrite=FileWrite(handle,text);
      if(checkwrite==0)
         Print("Error writing to file ",FileName,". Error- ",ErrorDescription(GetLastError() ) );
        }
     else
     if(obtype==OBJ_HLINE)
        {
        text=name+",HLine,";
        window=IntegerToString(ObjectFind(0,name));
        t1=TimeToStr((datetime)ObjectGet(name,OBJPROP_TIME1));
        p1=DoubleToStr(ObjectGet(name,OBJPROP_PRICE1),Digits);
        col=IntegerToString(ObjectGetInteger(0,name,OBJPROP_COLOR));
        width=IntegerToString((int)ObjectGet(name,OBJPROP_WIDTH));
        style=IntegerToString((int)ObjectGet(name,OBJPROP_STYLE));
        back=IntegerToString(ObjectGetInteger(0,name,OBJPROP_BACK));
        text+=window+","+t1+","+p1+","+col+","+width+","+style+","+back;
      uint checkwrite=FileWrite(handle,text);
      if(checkwrite==0)
         Print("Error writing to file ",FileName,". Error- ",ErrorDescription(GetLastError() ) );
        }
     }
  
  //Print(text);
      FileFlush(handle);
      FileClose(handle);
//---
   
  }
//+------------------------------------------------------------------+
//+------------------------------------------------------------------+

void PrintToFile(string printstring)
  {
   ResetLastError();
   int handle = FileOpen(FileName,FILE_SHARE_READ|FILE_READ|FILE_WRITE|FILE_CSV )  ;
   if(handle<0)
     {
     Print("Error opening file ",FileName,". Error- ",ErrorDescription(GetLastError() ) );
     return;
     }
   
     FileSeek(handle,0,SEEK_END);
      uint checkwrite=FileWrite(handle,printstring);
      if(checkwrite==0)
         Print("Error writing to file ",FileName,". Error- ",ErrorDescription(GetLastError() ) );
      FileFlush(handle);
      FileClose(handle);

   }
